package com.mobile.night

import android.content.Context
import android.support.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

/** DarkPlugin */
public class NightPlugin : FlutterPlugin, MethodCallHandler {
  var context: Context? = null
  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    context = flutterPluginBinding.applicationContext
    val channel = MethodChannel(flutterPluginBinding.flutterEngine.dartExecutor, "night")
    channel.setMethodCallHandler(NightPlugin());
  }

  // This static function is optional and equivalent to onAttachedToEngine. It supports the old
  // pre-Flutter-1.12 Android projects. You are encouraged to continue supporting
  // plugin registration via this function while apps migrate to use the new Android APIs
  // post-flutter-1.12 via https://flutter.dev/go/android-project-migration.
  //
  // It is encouraged to share logic between onAttachedToEngine and registerWith to keep
  // them functionally equivalent. Only one of onAttachedToEngine or registerWith will be called
  // depending on the user's project. onAttachedToEngine or registerWith must both be defined
  // in the same class.
  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "night")
      channel.setMethodCallHandler(NightPlugin())
    }
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
    when (call.method) {
      "getDefaultNightMode" -> result.success(DarkThemeTools.getDefaultNightMode())
      "isSystemTheme" -> result.success(DarkThemeTools.isSystemTheme())
      "isDarkTheme" -> result.success(DarkThemeTools.isDarkTheme(context!!))
      "updateSystemTheme" -> result.success(DarkThemeTools.updateSystemTheme(call.arguments is Boolean, context!!))
      "updateNightTheme" -> result.success(DarkThemeTools.updateNightTheme(call.arguments is Boolean))
      else -> result.notImplemented()
    }
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
  }
}
